unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    TrackX: TTrackBar;
    TrackY: TTrackBar;
    TrackZ: TTrackBar;
    TrackV: TTrackBar;
    Image1: TImage;
    PaintBox2: TPaintBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1Paint(Sender: TObject);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure TrackXChange(Sender: TObject);
    procedure PaintBox2Paint(Sender: TObject);
  private
    Gazo: TBitmap;

    Bmp1, Bmp2: TBitmap;
    FDragging: Boolean;
    FDragStart: TPoint;
    FRect: TRect;
  public

  end;

var
  Form1: TForm1;

implementation

uses
    iRotate, Types;

{$R *.dfm}

//  Bitmap쐬
procedure   Create24bitBitmap(var Bmp: TBitmap; const W, H: integer);
begin
    Bmp := TBitmap.Create;
    Bmp.Width := W;
    Bmp.Height := H;
    Bmp.PixelFormat := pf24bit;
end;

//  BitmapNA
procedure   ClearBitmap(Bmp: TBitmap; const C: TColor; const S: TBrushStyle);
var
    BkC: TColor;
    BkS: TBrushStyle;
begin
    BkC := Bmp.Canvas.Brush.Color;
    BkS := Bmp.Canvas.Brush.Style;
    Bmp.Canvas.Brush.Color := C;
    Bmp.Canvas.Brush.Style := S;
    Bmp.Canvas.FillRect(Rect(0, 0, Bmp.Width, Bmp.Height));
    Bmp.Canvas.Brush.Color := BkC;
    Bmp.Canvas.Brush.Style := BkS;
end;

//  h~
procedure   SetPaintBox(Sender: TPaintBox);
begin
    Sender.ControlStyle := Sender.ControlStyle + [csOpaque]; 
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
    //  tH[^Cgݒ
    Self.Caption := ChangeFileExt(ExtractFileName(ParamStr(0)), '');
    //  
    FDragging := false;
    FRect := Rect(0, 0, 1, 1);
    //  Bitmap쐬
    Create24bitBitmap(Bmp1, PaintBox1.Width, PaintBox1.Height);
    Create24bitBitmap(Bmp2, PaintBox2.Width, PaintBox2.Height);
    //  ܂
    Gazo := TBitmap.Create;
    Gazo.Assign(Image1.Picture.Bitmap);
    Gazo.PixelFormat := pf24bit;
    //  h~
    SetPaintBox(PaintBox1);
    SetPaintBox(PaintBox2);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
    Bmp1.Free;
    Bmp2.Free;
    Gazo.Free;
end;

procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    FDragging := true;          //  hbOJn
    FDragStart := Point(X, Y);  //  hbOJnʒuL^
    PaintBox1.Repaint;          //  `v
end;

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
    //  hbOȂ
    if FDragging then
    begin
        ClearBitmap(Bmp1, clWhite, bsSolid);
        BitBlt(Bmp1.Canvas.Handle, 0, 0, Bmp1.Width, Bmp1.Height, Gazo.Canvas.Handle, 0, 0, SRCCOPY);
        //  obt@OBitmapɊiqɌ(mO)̕`Rect`
        Bmp1.Canvas.Brush.Color := clBlack;
        Bmp1.Canvas.Brush.Style := bsDiagCross;
        Bmp1.Canvas.Rectangle(FDragStart.X, FDragStart.Y, X, Y);
        //  `v
        PaintBox1.Repaint;
    end;
end;

procedure TForm1.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    //  hbOI
    FDragging := false;
    //  `Rectm
    FRect := Rect(FDragStart.X, FDragStart.Y, X, Y);
    //  ]p
    TrackX.Position := 0;
    TrackY.Position := 0;
    TrackZ.Position := 0;
    //  `Rectobt@OBitmapɕ`
    ClearBitmap(Bmp1, clWhite, bsSolid);
    BitBlt(Bmp1.Canvas.Handle, 0, 0, Bmp1.Width, Bmp1.Height, Gazo.Canvas.Handle, 0, 0, SRCCOPY);
    Bmp1.Canvas.Rectangle(FRect);
    //  `v
    PaintBox1.Repaint;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
var
    PB: TPaintBox;
begin
    PB := TPaintBox(Sender);
    BitBlt(PB.Canvas.Handle, 0, 0, PB.Width, PB.Height, Bmp1.Canvas.Handle, 0, 0, SRCCOPY);
end;

procedure TForm1.PaintBox2Paint(Sender: TObject);
var
    PB: TPaintBox;
begin
    PB := TPaintBox(Sender);
    BitBlt(PB.Canvas.Handle, 0, 0, PB.Width, PB.Height, Bmp2.Canvas.Handle, 0, 0, SRCCOPY);
end;

procedure TForm1.TrackXChange(Sender: TObject);
var
    X, Y, Z, V: integer;
    Box: TRect;
begin
    X := TrackX.Position;
    Y := TrackY.Position;
    Z := TrackZ.Position;
    V := TrackV.Position;

    ClearBitmap(Bmp1, clWhite, bsSolid);
    BitBlt(Bmp1.Canvas.Handle, 0, 0, Bmp1.Width, Bmp1.Height, Gazo.Canvas.Handle, 0, 0, SRCCOPY);
    Bmp1.Canvas.Brush.Color := clBlue;
    DrawRotatedRect(Bmp1.Canvas, FRect, X, Y, Z, V, false);
    Box := GetDegRotatedRectBox(FRect, X, Y, Z, V);
    Bmp1.Canvas.FrameRect(Box);
    PaintBox1.Repaint;

    RotateDegBitmap(Gazo, FRect, Bmp2, X, Y, Z, V);
    Bmp2.Width := PaintBox2.Width;
    Bmp2.Height := PaintBox2.Height;
    PaintBox2.Repaint();
end;

end.

